-- GeorgianTrait_setup
-- Author: Mostly Machiavelli24, except a changed a few things
-- DateCreated: 6/11/2014 11:58:50 AM
--------------------------------------------------------------

-- NOTE: We'll probably use this code, but due to Machiavelli's
--       brilliant suggestion to make sure it works first, for
--       the time being it will go unused.

-- NOTE: This first section was basically a shameless rip-off of a function from
--       Machiavelli24's Religion Snippets, though it is also found in his Race
--		 for Religion mod. The reason I'm not just using his function is because
--       the hope is that I can replicate its functionality while using 11x fewer
--       dummy buildings and limiting its use to Georgia.

--		 Hopefully it works. :/

GameEvents.CityConvertsReligion.Add(
function(iPlayer, iReligion, iX, iY)

	-- First set up boolean variable firstConversion to be used later	

	local plot = Map.GetPlot(iX, iY);
	if not (plot:IsCity()) then
		return;
	end
	
	local city = plot:GetPlotCity();
	local isReligion = GameInfoTypes.BUILDING_GEORGIA_DUMMY_IS_RELIGION
	local hasBeenReligion = GameInfoTypes.BUILDING_GEORGIA_DUMMY_HAS_BEEN_RELIGION

	if (city:GetOwner() == iPlayer)
	and (iPlayer:GetCivilizationType() == GameInfoTypes.CIVILIZATION_GEORGIA) then
		if (iPlayer:HasCreatedReligion()) then
			local iReligion = iPlayer:GetReligionCreatedByPlayer()
			
			if (city:GetReligiousMajority() == iReligion) then
				if not (city:IsHasBuilding(isReligion)) then
					city:SetNumRealBuilding(isReligion, 1)
				else
					if not (city:IsHasBuilding(hasBeenReligion)) then
						firstConversion = true;
						city:SetNumRealBuilding(hasBeenReligion, 1)
					else
						firstConversion = false;
					end
				end
			else
				city:SetNumRealBuilding(isReligion, 0)
			end
		end
	end
	print("Georgian City Converts Religon Event: (iPlayer: " ..tostring(iPlayer).. " iX: " ..tostring(iX).. " iY: " ..tostring(iY).. "iReligion: " ..tostring(iReligion).. "firstConversion: " ..tostring(firstConversion).. ")");
	LuaEvents.GeorgianCityConvertsReligion(iPlayer, iX, iY, iReligion, firstConversion);
	
	-- This next part was copied directly from Machiavelli24's Lua, except with 
	-- some function names changed. It's an "initialization check", to make sure 
	-- the code doesn't run twice.
	
	local retVal = {};
	LuaEvents.GeorgianCityConvertsReligion_IsInitialized(retVal);

	-- If retVal isn't changed, no other mod has initialized this code.
	if (retVal.isInitialized == nil) then
		LuaEvents.GeorgianCityConvertsReligion_IsInitialized.Add(function (retVal) retVal.isInitialized = true; end);		
	end)
end)

-- Now we move on to the second section, which was pretty much directly copied
-- from Machiavelli24's Religion Snippets, though of necessity I had to change
-- the event hook name.

function CallReligionFoundedEvent(iOwner, iX, iY, eOldReligion, eNewReligion, bFirstConversion)
	local plot = Map.GetPlot(iX, iY);
	local city = plot:GetPlotCity();
	
	if(city:IsHolyCityForReligion(eNewReligion) and bFirstConversion) then
		LuaEvents.GeorgianReligionFoundedEvent(iOwner, iX, iY, eOldReligion, eNewReligion);
	end
end

--------------
-- Initialization check.  Ensures this code isn't loaded twice
--------------
local retVal = {};
LuaEvents.GeorgianReligionFoundedEvent_IsInitialized(retVal);

-- If retVal isn't changed, no other mod has initialized this code.
if (retVal.isInitialized == nil) then
	LuaEvents.GeorgianReligionFoundedEvent_IsInitialized.Add(function (retVal) retVal.isInitialized = true; end);
	-- Initialize the code
	LuaEvents.GeorgianCityConvertsReligion.Add(CallReligionFoundedEvent);
end