-- temp_GeorgianTrait_ReligionFirstBonus
-- Author: Machiavelli24
-- DateCreated: 6/12/2014 1:44:32 PM
--------------------------------------------------------------
-- temp_GeorgianTrait_ReligionFirstBonus
-- Author: Machiavelli24
-- DateCreated: 6/12/2014 1:44:32 PM
--------------------------------------------------------------
--[[
	UA:
	If founds religion, cities next to mountains produce extra faith
	"  "      "        first, 3 missionaries 
	"  "      "        and is your majority religion, cities cannot be converted
]]--
--[[ print('Totes m\'goats')
function GeorgiaFoundingBonus(founderID, iX, iY, eOldReligion, eNewReligion)
  player = Players[founderID];
  city = Game.GetHolyCityForReligion(eNewReligion, -1);

  if(player:GetCivilizationType() == GameInfoTypes.CIVILIZATION_GEORGIA and Game.GetNumReligionsFounded() == 1 and not city:IsHasBuilding(GameInfoTypes["BUILDING_GEORGIA_DUMMY_RELIGION_FIRST"])) then
    city:SetNumRealBuilding(GameInfoTypes["BUILDING_GEORGIA_DUMMY_RELIGION_FIRST"], 1);
  end
end
LuaEvents.ReligionFoundedEvent.Add(GeorgiaFoundingBonus);

GameEvents.PlayerDoTurn.Add(
function(iPlayer)
	local iPlayer = Players[iPlayer]
	if (iPlayer:HasCreatedReligion()) then
		iReligion = iPlayer:GetReligionCreatedByPlayer()
		if Game.GetHolyCityForReligion(iReligion):IsHasBuilding(GameInfoTypes.BUILDING_GEORGIA_DUMMY_RELIGION_FIRST) then
			iPlayer:ChangeFaith(math.ceil(Game.GetNumFollowers(iReligion)/4))
		end
	else
		return;
	end
end) ]]--

print('It\'s Working!')

include("NewSaveUtils.lua"); MY_MOD_NAME = "Kingdom of Georgia";

local iAWCiv = GameInfoTypes.CIVILIZATION_GEORGIA
local PlayerCitiesTb = {}

function AWGeorgia(iOwner, eReligion, iX, iY)
	local pPlayer = Players[iOwner]
	if pPlayer:GetCivilizationType() == iAWCiv then
		local pPlot = Map.GetPlot(iX, iY)
		local pCity = pPlot:GetPlotCity()
		if pCity:GetReligiousMajority() ~= 0 and pCity:GetReligiousMajority() ~= -1 then -- If the city ReligiousMajority isn't a Pantheon nor inexistent, continue.
			local bNotPresent = true -- As default, we assume it is not present.
			for _, v in pairs(PlayerCitiesTb) do -- Check the table.
				if v == pCity then -- If it is present...
					bNotPresent = false -- We assumed wrong. Nothing else to do here, the code can end. You can even put a 'return' below this line to save a few precious milliseconds.
				end
			end
			if bNotPresent then -- The city wasn't found in the table, which means this is the first time there is a majority religion. So we add the city to the table and you perform your special code, whatever it is.
				-- PlayerCitiesTb[#t+1] = pCity
				table.insert(PlayerCitiesTb, pCity)
				if (pPlayer:HasCreatedReligion()) and (pCity:IsHolyCityForReligion(pPlayer:GetReligionCreatedByPlayer())) then -- if the player has founded a religion
				--[[ EFFECT #1: Faith Bonus in all cities next to mountains ]]--
					for mCity in pPlayer:Cities() do
						for direction = 0, DirectionTypes.NUM_DIRECTION_TYPES - 1, 1 do
							local pAdjacentPlot = Map.PlotDirection(pPlot:GetX(), pPlot:GetY(), direction)
							if pAdjacentPlot and pAdjacentPlot:IsMountain() then 
								mCity:SetNumRealBuilding(GameInfoTypes.BUILDING_GEORGIA_DUMMY_MOUNTAIN, 1)
							end
						end
					end
					SetPersistentProperty("AW_Georgia_ReligionFounded", true)
				end
			end
		end
	end
end
GameEvents.CityConvertsReligion.Add(AWGeorgia)
--[[ EFFECT #3: If  Georgia's majority religion is the one it founded, its cities can't be converted as long as they remain under Georgia control ]]--
GameEvents.CityConvertsReligion.Add(
function(iPlayer, iReligion, iX, iY)
	local pPlayer = Players[iPlayer]
	local pCity = Map.GetPlot(iX, iY):GetPlotCity()
	if not (pCity:GetOwner() == pPlayer) then
		return
	end
	if (pPlayer:GetCivilizationType() == iAWCiv) and (pPlayer:HasCreatedReligion()) then
		local pReligion = pPlayer:GetReligionCreatedByPlayer()
		if (pCity:GetReligiousMajority() == pReligion) and (pPlayer:HasReligionInMostCities(pReligion)) then
			pCity:AdoptReligionFully(pReligion)
		end
	end
end)
--[[ EFFECT 1 EXTENSION: All cities founded afterwards get the mountain bonus ]]--
GameEvents.PlayerCityFounded.Add(
function(iPlayer, iX, iY)
	local pPlayer = Players[iPlayer]
	local pCity = Map.GetPlot(iX, iY):GetPlotCity()
	if (pPlayer:GetCivilizationType() == iAWCiv) and (GetPersistentProperty("AW_Georgia_ReligionFounded") == true) then
		for direction = 0, DirectionTypes.NUM_DIRECTION_TYPES - 1, 1 do
			local pAdjacentPlot = Map.PlotDirection(pPlot:GetX(), pPlot:GetY(), direction)
			if pAdjacentPlot and pAdjacentPlot:IsMountain() then 
				pCity:SetNumRealBuilding(GameInfoTypes.BUILDING_GEORGIA_DUMMY_MOUNTAIN, 1)
			end
		end
	end
end)
GameEvents.PlayerDoTurn.Add(
function(iPlayer)
	local pPlayer = Players[iPlayer]
	if (pPlayer:GetCivilizationType() == iAWCiv) and (GetPersistentProperty("AW_Georgia_ReligionFounded") == true) then
		if (Game.GetNumReligionsFounded() == 1) and (GetPersistentProperty("AW_Georgia_MissionariesGiven") ~= true) then
			for pCity in pPlayer:Cities() do
				pCity:AdoptReligionFully(pPlayer:GetReligionCreatedByPlayer())
			end
			SetPersistentProperty("AW_Georgia_MissionariesGiven", true)
		end
	end
end)